import { defineComponent, $prefix, setup as _setup } from "@xmweb-ui/vue-common";
import { renderless, api } from "@xmweb-ui/vue-renderless/popconfirm/vue";
import Popover from "@xmweb-ui/vue-popover";
import Modal from "@xmweb-ui/vue-modal";
import Button from "@xmweb-ui/vue-button";
import { IconSuccess, IconInfoSolid, IconWarning, IconError } from "@xmweb-ui/vue-icon";
import { resolveComponent, openBlock, createElementBlock, createElementVNode, createVNode, withCtx, renderSlot, createBlock, resolveDynamicComponent, normalizeClass, createCommentVNode, toDisplayString, createTextVNode } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  name: $prefix + "Popconfirm",
  components: {
    XmPopover: Popover,
    XmModal: Modal,
    XmButton: Button,
    IconSuccess: IconSuccess(),
    IconInfoSolid: IconInfoSolid(),
    IconWarning: IconWarning(),
    IconError: IconError()
  },
  props: {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    content: String,
    popperClass: String,
    trigger: {
      type: String,
      default: "hover",
      validator: function validator(value) {
        return Boolean(~["click", "hover"].indexOf(value));
      }
    },
    cancelButton: {
      type: Boolean,
      default: true
    },
    title: String,
    placement: {
      type: String,
      default: "top"
    },
    width: {
      type: [String, Number],
      default: ""
    },
    type: [String, Object]
  },
  emits: ["hide", "show", "confirm"],
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var _hoisted_1 = {
  "data-tag": "xm-popconfirm",
  class: "inline-block"
};
var _hoisted_2 = {
  class: "hidden sm:inline-block"
};
var _hoisted_3 = {
  class: "py-1 text-xs text-color-text-primary"
};
var _hoisted_4 = {
  "data-tag": "xm-popconfirm-header",
  class: "flex items-center leading-6"
};
var _hoisted_5 = {
  class: "flex-auto"
};
var _hoisted_6 = {
  "data-tag": "xm-popconfirm-content",
  class: "text-color-text-secondary leading-6"
};
var _hoisted_7 = {
  class: "flex mt-4 justify-end"
};
var _hoisted_8 = {
  class: "sm:hidden inline-block"
};
var _hoisted_9 = {
  class: "flex text-base justify-center"
};
var _hoisted_10 = {
  key: 1,
  class: "border-r border-r-color-border-separator"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_xm_button = resolveComponent("xm-button");
  var _component_xm_popover = resolveComponent("xm-popover");
  var _component_xm_modal = resolveComponent("xm-modal");
  return openBlock(), createElementBlock("div", _hoisted_1, [createElementVNode("div", _hoisted_2, [createVNode(_component_xm_popover, {
    ref: "popover",
    xm_mode: "mobile-first",
    modelValue: _ctx.state.showPopover,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function($event) {
      return _ctx.state.showPopover = $event;
    }),
    placement: _ctx.placement,
    trigger: "manual",
    width: _ctx.width,
    "popper-class": _ctx.m("min-w-[10.5rem] max-w-[21.875rem] hidden sm:block", _ctx.popperClass),
    onShow: _ctx.show,
    onHide: _ctx.hide
  }, {
    reference: withCtx(function() {
      return [createElementVNode(
        "div",
        {
          class: "inline-block",
          onClick: _cache[0] || (_cache[0] = function($event) {
            return _ctx.show("click");
          }),
          onMouseover: _cache[1] || (_cache[1] = function($event) {
            return _ctx.show("hover");
          })
        },
        [renderSlot(_ctx.$slots, "reference")],
        32
        /* HYDRATE_EVENTS */
      )];
    }),
    default: withCtx(function() {
      return [createElementVNode("div", _hoisted_3, [createElementVNode("div", _hoisted_4, [_ctx.type ? (openBlock(), createBlock(resolveDynamicComponent(_ctx.state.getIcon), {
        key: 0,
        class: normalizeClass(_ctx.m("h-6 w-6 mr-2", {
          "fill-color-info-secondary": _ctx.type === "info"
        }, {
          "fill-color-error": _ctx.type === "error"
        }, {
          "fill-color-warning": _ctx.type === "warning"
        }, {
          "fill-color-success": _ctx.type === "success"
        }))
      }, null, 8, ["class"])) : createCommentVNode("v-if", true), createElementVNode(
        "div",
        _hoisted_5,
        toDisplayString(_ctx.title),
        1
        /* TEXT */
      )]), createElementVNode(
        "div",
        _hoisted_6,
        toDisplayString(_ctx.content),
        1
        /* TEXT */
      ), createElementVNode("div", _hoisted_7, [renderSlot(_ctx.$slots, "footer", {}, function() {
        return [_ctx.cancelButton ? (openBlock(), createBlock(_component_xm_button, {
          key: 0,
          class: "mr-2 w-16",
          size: "mini",
          xm_mode: "mobile-first",
          onClick: _ctx.hide
        }, {
          default: withCtx(function() {
            return [createTextVNode(
              toDisplayString(_ctx.t("ui.buttonMessage.cancel")),
              1
              /* TEXT */
            )];
          }),
          _: 1
          /* STABLE */
        }, 8, ["onClick"])) : createCommentVNode("v-if", true), createVNode(_component_xm_button, {
          class: "w-16",
          size: "mini",
          xm_mode: "mobile-first",
          type: "primary",
          onClick: _ctx.confirm
        }, {
          default: withCtx(function() {
            return [createTextVNode(
              toDisplayString(_ctx.t("ui.buttonMessage.confirm")),
              1
              /* TEXT */
            )];
          }),
          _: 1
          /* STABLE */
        }, 8, ["onClick"])];
      })])])];
    }),
    _: 3
    /* FORWARDED */
  }, 8, ["modelValue", "placement", "width", "popper-class", "onShow", "onHide"])]), createElementVNode("div", _hoisted_8, [createElementVNode(
    "div",
    {
      class: "inline-block",
      onClick: _cache[3] || (_cache[3] = function($event) {
        return _ctx.show("click");
      }),
      onMouseover: _cache[4] || (_cache[4] = function($event) {
        return _ctx.show("hover");
      })
    },
    [renderSlot(_ctx.$slots, "reference")],
    32
    /* HYDRATE_EVENTS */
  ), createVNode(_component_xm_modal, {
    ref: "modal",
    xm_mode: "mobile-first",
    class: "sm:hidden",
    modelValue: _ctx.state.showPopover,
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function($event) {
      return _ctx.state.showPopover = $event;
    }),
    title: _ctx.title,
    "show-footer": ""
  }, {
    default: withCtx(function() {
      return [createTextVNode(
        toDisplayString(_ctx.content),
        1
        /* TEXT */
      )];
    }),
    footer: withCtx(function() {
      return [createElementVNode("div", _hoisted_9, [renderSlot(_ctx.$slots, "footer", {}, function() {
        return [_ctx.cancelButton ? (openBlock(), createBlock(_component_xm_button, {
          key: 0,
          class: "flex-1 text-color-text-secondary",
          xm_mode: "mobile-first",
          type: "text",
          onClick: _ctx.hide
        }, {
          default: withCtx(function() {
            return [createTextVNode(
              toDisplayString(_ctx.t("ui.buttonMessage.cancel")),
              1
              /* TEXT */
            )];
          }),
          _: 1
          /* STABLE */
        }, 8, ["onClick"])) : createCommentVNode("v-if", true), _ctx.cancelButton ? (openBlock(), createElementBlock("span", _hoisted_10)) : createCommentVNode("v-if", true), createVNode(_component_xm_button, {
          class: "flex-1 text-color-brand xm-modal-mf-button",
          xm_mode: "mobile-first",
          type: "text",
          onClick: _ctx.confirm
        }, {
          default: withCtx(function() {
            return [createTextVNode(
              toDisplayString(_ctx.t("ui.buttonMessage.confirm")),
              1
              /* TEXT */
            )];
          }),
          _: 1
          /* STABLE */
        }, 8, ["onClick"])];
      })])];
    }),
    _: 3
    /* FORWARDED */
  }, 8, ["modelValue", "title"])])]);
}
var mobileFirst = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  mobileFirst as default
};
